<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: HttpRequest.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HttpRequest.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * HTTPRequest.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Aug 30, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_HTTPREQUEST_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_HTTPREQUEST_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;Socket.h&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;WebSocket.h&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;HttpParser.h&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#undef close</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classHttpRequest.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="classHttpRequest.html">HttpRequest</a> {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <a class="code" href="classHttpRequest.html#a866f33e85b736b32f0084d64a716529c">HttpRequest</a>(<a class="code" href="classSocket.html">Socket</a> s);</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classHttpRequest.html">HttpRequest</a>();</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_ACCEPT[];</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_ALLOW[];</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_CONNECTION[];</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_CONTENT_LENGTH[];</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_CONTENT_TYPE[];</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_COOKIE[];</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_HOST[];</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_LAST_MODIFIED[];</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_ORIGIN[];</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_SEC_WEBSOCKET_ACCEPT[];</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_SEC_WEBSOCKET_PROTOCOL[];</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_SEC_WEBSOCKET_KEY[];</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_SEC_WEBSOCKET_VERSION[];</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_UPGRADE[];</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_HEADER_USER_AGENT[];</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_CONNECT[];</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_DELETE[];</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_GET[];</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_HEAD[];</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_OPTIONS[];</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_PATCH[];</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_POST[];</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span> HTTP_METHOD_PUT[];</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpRequest.html#a970869c3e73fb4cf6758793e5fa27471">close</a>();                      <span class="comment">// Close the connection to the client.</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">void</span>                               <a class="code" href="classHttpRequest.html#a0a5ce3688a7340c0e04b026c51ee5154">dump</a>();                       <span class="comment">// Diagnostic dump of the Http request.</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    std::string                        <a class="code" href="classHttpRequest.html#afbdb7737b89853ed346dd61c51e1836f">getBody</a>();                    <span class="comment">// Get the body of the request.</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    std::string                        <a class="code" href="classHttpRequest.html#ab252baed3c7368fd26708c299bf89e34">getHeader</a>(std::string name);  <span class="comment">// Get the value of a named header.</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    std::map&lt;std::string, std::string&gt; getHeaders();                 <span class="comment">// Get all the headers.</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    std::string                        getMethod();                  <span class="comment">// Get the request method.</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    std::string                        getPath();                    <span class="comment">// Get the request path.</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    std::map&lt;std::string, std::string&gt; <a class="code" href="classHttpRequest.html#ab09977e9201d7b79d0f77d416096d707">getQuery</a>();                   <span class="comment">// Get the query part of the request.</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="classSocket.html">Socket</a>                             <a class="code" href="classHttpRequest.html#a704e22a6312c4b88d3a13803893faccf">getSocket</a>();                  <span class="comment">// Get the underlying TCP/IP socket.</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    std::string                        getVersion();                 <span class="comment">// Get the HTTP version.</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <a class="code" href="classWebSocket.html">WebSocket</a>*                         getWebSocket();               <span class="comment">// Get the WebSocket reference if this is a web socket.</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">bool</span>                               <a class="code" href="classHttpRequest.html#a219c6b9d700e5940d86d909e4c9a0169">isClosed</a>();                   <span class="comment">// Has the connection been closed?</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">bool</span>                               <a class="code" href="classHttpRequest.html#ada6a0b548a6a104d1e94b17f6c96d5fe">isWebsocket</a>();                <span class="comment">// Is this request to create a web socket?</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    std::map&lt;std::string, std::string&gt; <a class="code" href="classHttpRequest.html#a53f09999b5f93920c79eed1423a490cf">parseForm</a>();                  <span class="comment">// Parse the body as a form.</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    std::vector&lt;std::string&gt;           <a class="code" href="classHttpRequest.html#a69559e9b796efa4ba6abaefffc77ddd0">pathSplit</a>();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    std::string                        <a class="code" href="classHttpRequest.html#a33588e0cf0864e1be7c519f7d491e01e">urlDecode</a>(std::string str);   <span class="comment">// Decode a URL.</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <a class="code" href="classSocket.html">Socket</a>    m_clientSocket; <span class="comment">// The socket connected to the client.</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">bool</span>        m_isClosed;  <span class="comment">// Is the client connection closed?</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="classHttpParser.html">HttpParser</a>  m_parser;      <span class="comment">// The parse to parse HTTP data.</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="classWebSocket.html">WebSocket</a>*  m_pWebSocket;   <span class="comment">// A possible reference to a WebSocket object instance.</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;};</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_HTTPREQUEST_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classHttpRequest_html_ada6a0b548a6a104d1e94b17f6c96d5fe"><div class="ttname"><a href="classHttpRequest.html#ada6a0b548a6a104d1e94b17f6c96d5fe">HttpRequest::isWebsocket</a></div><div class="ttdeci">bool isWebsocket()</div><div class="ttdoc">Determine if this request represents a WebSocket.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:294</div></div>
<div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classHttpRequest_html_a704e22a6312c4b88d3a13803893faccf"><div class="ttname"><a href="classHttpRequest.html#a704e22a6312c4b88d3a13803893faccf">HttpRequest::getSocket</a></div><div class="ttdeci">Socket getSocket()</div><div class="ttdoc">Get the underlying socket.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:266</div></div>
<div class="ttc" id="classHttpRequest_html_ab09977e9201d7b79d0f77d416096d707"><div class="ttname"><a href="classHttpRequest.html#ab09977e9201d7b79d0f77d416096d707">HttpRequest::getQuery</a></div><div class="ttdeci">std::map&lt; std::string, std::string &gt; getQuery()</div><div class="ttdoc">Get the query part of the request. The query is a set of name = value pairs. The return is a map keye...</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:210</div></div>
<div class="ttc" id="classHttpRequest_html_a69559e9b796efa4ba6abaefffc77ddd0"><div class="ttname"><a href="classHttpRequest.html#a69559e9b796efa4ba6abaefffc77ddd0">HttpRequest::pathSplit</a></div><div class="ttdeci">std::vector&lt; std::string &gt; pathSplit()</div><div class="ttdoc">Return the constituent parts of the path. If we imagine a path as composed of parts separated by slas...</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:346</div></div>
<div class="ttc" id="classWebSocket_html"><div class="ttname"><a href="classWebSocket.html">WebSocket</a></div><div class="ttdef"><b>Definition:</b> WebSocket.h:60</div></div>
<div class="ttc" id="classHttpRequest_html_a33588e0cf0864e1be7c519f7d491e01e"><div class="ttname"><a href="classHttpRequest.html#a33588e0cf0864e1be7c519f7d491e01e">HttpRequest::urlDecode</a></div><div class="ttdeci">std::string urlDecode(std::string str)</div><div class="ttdoc">Decode a URL/form.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:366</div></div>
<div class="ttc" id="classHttpRequest_html_afbdb7737b89853ed346dd61c51e1836f"><div class="ttname"><a href="classHttpRequest.html#afbdb7737b89853ed346dd61c51e1836f">HttpRequest::getBody</a></div><div class="ttdeci">std::string getBody()</div><div class="ttdoc">Get the body of the HttpRequest.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:174</div></div>
<div class="ttc" id="classHttpRequest_html_a53f09999b5f93920c79eed1423a490cf"><div class="ttname"><a href="classHttpRequest.html#a53f09999b5f93920c79eed1423a490cf">HttpRequest::parseForm</a></div><div class="ttdeci">std::map&lt; std::string, std::string &gt; parseForm()</div><div class="ttdoc">Parse the request message as a form.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:303</div></div>
<div class="ttc" id="classHttpRequest_html_a0a5ce3688a7340c0e04b026c51ee5154"><div class="ttname"><a href="classHttpRequest.html#a0a5ce3688a7340c0e04b026c51ee5154">HttpRequest::dump</a></div><div class="ttdeci">void dump()</div><div class="ttdoc">Dump the HttpRequest for debugging purposes.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:160</div></div>
<div class="ttc" id="classHttpParser_html"><div class="ttname"><a href="classHttpParser.html">HttpParser</a></div><div class="ttdef"><b>Definition:</b> HttpParser.h:14</div></div>
<div class="ttc" id="classHttpRequest_html_a970869c3e73fb4cf6758793e5fa27471"><div class="ttname"><a href="classHttpRequest.html#a970869c3e73fb4cf6758793e5fa27471">HttpRequest::close</a></div><div class="ttdeci">void close()</div><div class="ttdoc">Close the HttpRequest.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:148</div></div>
<div class="ttc" id="classHttpRequest_html"><div class="ttname"><a href="classHttpRequest.html">HttpRequest</a></div><div class="ttdef"><b>Definition:</b> HttpRequest.h:19</div></div>
<div class="ttc" id="classHttpRequest_html_a866f33e85b736b32f0084d64a716529c"><div class="ttname"><a href="classHttpRequest.html#a866f33e85b736b32f0084d64a716529c">HttpRequest::HttpRequest</a></div><div class="ttdeci">HttpRequest(Socket s)</div><div class="ttdoc">Create an HTTP Request instance.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:95</div></div>
<div class="ttc" id="classHttpRequest_html_a219c6b9d700e5940d86d909e4c9a0169"><div class="ttname"><a href="classHttpRequest.html#a219c6b9d700e5940d86d909e4c9a0169">HttpRequest::isClosed</a></div><div class="ttdeci">bool isClosed()</div><div class="ttdoc">Determine if the request is closed.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:285</div></div>
<div class="ttc" id="classHttpRequest_html_ab252baed3c7368fd26708c299bf89e34"><div class="ttname"><a href="classHttpRequest.html#ab252baed3c7368fd26708c299bf89e34">HttpRequest::getHeader</a></div><div class="ttdeci">std::string getHeader(std::string name)</div><div class="ttdoc">Get the named header.</div><div class="ttdef"><b>Definition:</b> HttpRequest.cpp:184</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
